// Parametric Knob
// Made by Lucian Brandus - oct 2014

// physical parameters

d_buton = 16;  // knob diameter
h_buton = 17; // knob height
g_buton = 2.4; // knob wall width
conicitate = 2; // taper (how many mm is top lower as against base)

d_ax = 10; // interior shaft diameter
d_gaura_ax = 6; // hole shaft diameter
h_ax = 12.5; // shaft height

d_rizuri = 4; // knurls diameter
nr_rizuri = 10; // knurls number
h_rizuri = 12; // knurls height
a_rizuri = 1.2; // knurls delth

d_guler = 20; // colar diameter
h_guler = 3; // total colar height
h_margine = 0.8; // colar edge height

unghi = atan(conicitate/2/(h_buton-h_guler));

// Knob body

difference()
{
	union()
		{
		// body
		cylinder (h = h_buton-h_guler, d1 = d_buton-conicitate, d2 = d_buton, $fn=50);
	
		// colar edge
		translate([0,0,h_buton-h_margine])
		cylinder (h = h_margine, d = d_guler, $fn=50);
	
		// colar
		translate([0,0,h_buton-h_guler])
		cylinder (h = h_guler-h_margine, d1 = d_buton, d2 = d_guler, $fn=50);
		}
	
	// interior
	translate([0,0,g_buton])
	cylinder (h = h_buton, d = d_buton-g_buton*2, $fn=50);

	// knurls
	for ( i = [1 : nr_rizuri] )
	{
		rotate([0, unghi, i*360/nr_rizuri])
		translate([(d_buton/2+(d_buton/2-conicitate))/2+d_rizuri/2-a_rizuri/2,0,0])
		cylinder(h = h_rizuri, d = d_rizuri, $fn=20);
	
	}
}

// Knob shaft
		
difference()
{
	// body
	cylinder (h = h_ax, d = d_ax, $fn=50);
	
	// hole
	translate([0,0,g_buton])
	cylinder (h = h_ax, d = d_gaura_ax, $fn=50);
}